' --------------------------------------------------------------------------------------------------------------------
' <copyright file="IoC.cs" company="Web Advanced">
' Copyright 2012 Web Advanced (www.webadvanced.com)
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.
' </copyright>
' --------------------------------------------------------------------------------------------------------------------

Imports CustomerManagement.Core.Services
Imports CustomerManagement.Infrastructure.Interfaces
Imports Shareds.Interfaces
Imports StructureMap
Imports StructureMap.Graph

Namespace CustomerManagementTests.DependencyResolution

  Public NotInheritable Class IoC

	Private Sub New()
	End Sub
	Public Shared Function Initialize() As IContainer

#If true Then
		' Wire up Message Publisher
	  ObjectFactory.Configure(Sub(cfg)

		  cfg.Scan(Sub(scan)

			  scan.TheCallingAssembly()
			  scan.WithDefaultConventions()
			  scan.AssemblyContainingType(Of CustomerUpdatedService)()
			  scan.AssemblyContainingType(Of IApplicationEvent)()
			  scan.ConnectImplementationsToTypesClosing(GetType(IHandle(Of )))

		  End Sub)
		  cfg.For(Of IMessagePublisher)().Use(Of RabbitMqMessagePublisher)()

	  End Sub)
	  Return ObjectFactory.Container
#End If

#If false Then
					  ' Wire up Message Publisher
		Return New Container(Sub(cfg)

			cfg.Scan(Sub(scan)

				scan.TheCallingAssembly()
				scan.WithDefaultConventions()
				scan.AssemblyContainingType(Of CustomerUpdatedService)()
				scan.AssemblyContainingType(Of IApplicationEvent)()
				scan.ConnectImplementationsToTypesClosing(GetType(IHandle(Of )))

			End Sub)
			cfg.For(Of IMessagePublisher)().Use(Of RabbitMqMessagePublisher)()

		End Sub)
#End If

	End Function

  End Class

End Namespace